"
 COPYRIGHT (c) 1999 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"


SocketAddress variableByteSubclass:#AppletalkSocketAddress
	instanceVariableNames:'port'
	classVariableNames:''
	poolDictionaries:''
	category:'OS-Sockets'
!

!AppletalkSocketAddress class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1999 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

!

documentation
"
    Instances of AppletalkSocketAddress represent appletalk socket addresses.
    These consist of a network (2 bytes), a node (1 byte) and a port number.


    [author:]
        Claus Gittinger (cg@exept)

    [see also:]

    [instance variables:]

    [class variables:]
"
! !

!AppletalkSocketAddress class methodsFor:'instance creation'!

new
    ^ self new:3
! !

!AppletalkSocketAddress class methodsFor:'queries'!

hostAddressByName: hostName
    ^ Socket appletalkAddressOfHost:hostName

    "
     AppletalkSocketAddress hostAddressByName:'clam'   
     AppletalkSocketAddress hostAddressByName:'foobar' 
    "


!

hostNameByAddress:anAddress
    ^ Socket hostWithAppletalkAddress:anAddress

    "
     AppletalkSocketAddress hostNameByAddress:#[1 2 3].
    "

! !

!AppletalkSocketAddress methodsFor:'accessing'!

net
    ^ ((self at:1) bitShift:8) bitOr:(self at:2)


!

net:aNodeAddress
    self at:1 put:((aNodeAddress bitShift:-1) bitAnd:16rFF).
    self at:2 put:(aNodeAddress bitAnd:16rFF).

    "
     self new net:16r1234
    "
!

net:netNr node:nodeNr port:portNr
    self 
        net:netNr;
        node:nodeNr;
        port:portNr

    "
     AppletalkSocketAddress new net:1234 node:10 port:20
    "
    "
     AppletalkSocketAddress hostAddress:#[1 2 3] port:10
    "
!

node
    ^ self at:3


!

node:aNodeNr
    self at:3 put:aNodeNr


!

port
    ^ port

!

port:aPortNr
    port := aPortNr

! !

!AppletalkSocketAddress methodsFor:'printing & storing'!

printOn:aStream
    "append a user printed representation of the receiver to aStream.
     The format is suitable for a human - not meant to be read back."

    self net printOn:aStream.
    aStream nextPut:$:.
    self node printOn:aStream.
    port notNil ifTrue:[
        aStream nextPut:$:.
        port printOn:aStream.
    ].


! !

!AppletalkSocketAddress methodsFor:'queries'!

hostName
    ^ Socket hostWithAppletalkAddress:self


!

portOrName
    ^ port

! !

!AppletalkSocketAddress class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libbasic2/AppletalkSocketAddress.st,v 1.2 1999-09-21 00:27:14 cg Exp $'
! !
